//+------------------------------------------------------------------+
//|                                         Three moving averages EA |
//|                              Copyright  2008, TradingSytemForex |
//|                                http://www.tradingsystemforex.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, TradingSytemForex"
#property link "http://www.tradingsystemforex.com"

#define OrSt "Three moving averages EA"

extern string IS="---------------- Indicator Settings";
extern int    Length          = 20;
extern int    Price           = PRICE_CLOSE;

extern double Short_Period=9;
extern double Middle_Period=30;
extern double Long_Period=50;
extern double Mode_MA=0; //0=simple, 1=exponential, 2=smoothed, 3=linea weighted
extern string LM="---------------- Lot Management";
extern double Lots=0.1;
extern bool MM=false; //money management
extern double Risk=10; //risk in percentage
extern string TSTB="---------------- TP SL TS BE";
bool RealSL_Enabled=false;
int RealSL=5; //stop loss under 15 pps
bool RealTP_Enabled=false;
int RealTP=10; //take profit under 10 pps
extern int SL=0; //stop loss
extern int TP=0; //take profit
extern int TS=0; //trailing stop
extern int TS_Step=1; //trailing stop step
extern int BE=0; //breakeven
extern string EXT="---------------- Extras";
extern bool Reverse=false;
extern bool Add_Positions=False; //positions cumulated
extern int MaxOrders=1; //maximum number of orders
extern int Magic=0;

datetime       timeprev       = 0;
double pointvalue;

   int Slip=3;static int TL=0;double MML=0;
   int init() 
    {
	  /*MagicNumber=5000+func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(Period()); 
      setup="RK-NonLagMAwDMI_ADX8 " + Symbol() + "_" + func_TimeFrame_Val2String
                                    (func_TimeFrame_Const2Val(Period()));
     */
      //Convert to 3 & 5 diget broker
      if (Digits == 4 || Digits == 2) pointvalue = Point;
         else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
       
   }
   // expert start function
 int start()
 {
   // Only run once per completed bar L-118
       if(timeprev==Time[0]) return(0);
      timeprev = Time[0];

   int j=0,limit=1;
   double BV=0,SV=0,CBV=0, CSV=0;
   double SMA1a,SMA1b,SMA2a,SMA2b,SMA3a,SMA3b;
   if(CntO(OP_BUY,Magic)>0) TL=1;
   if(CntO(OP_SELL,Magic)>0) TL=-1;
  for(int i=1;i<=limit;i++)   
   {
    /*   SMA1a=iMA(Symbol(),0,Short_Period,0,Mode_MA,PRICE_CLOSE,i+1);
     SMA1b=iMA(Symbol(),0,Short_Period,0,Mode_MA,PRICE_CLOSE,i);
     SMA2a=iMA(Symbol(),0,Middle_Period,0,Mode_MA,PRICE_CLOSE,i+1);
     SMA2b=iMA(Symbol(),0,Middle_Period,0,Mode_MA,PRICE_CLOSE,i);
     SMA3a=iMA(Symbol(),0,Long_Period,0,Mode_MA,PRICE_CLOSE,i+1);
     SMA3b=iMA(Symbol(),0,Long_Period,0,Mode_MA,PRICE_CLOSE,i);
    */
     SMA1a=iCustom(Symbol(),0,"ml-Zero lag Hull moving average - histo & alerts","M15", Length, Price,0,i+1);
     SMA1b=iCustom(Symbol(),0,"ml-Zero lag Hull moving average - histo & alerts","M15", Length, Price,1,i+1);
     SMA2a=iCustom(Symbol(),0,"ml-Zero lag Hull moving average - histo & alerts","H1", Length, Price,0,i+1);
     SMA2b=iCustom(Symbol(),0,"ml-Zero lag Hull moving average - histo & alerts","H1", Length, Price,1,i+1);
     SMA3a=iCustom(Symbol(),0,"ml-Zero lag Hull moving average - histo & alerts","H4", Length, Price,0,i+1);
     SMA3b=iCustom(Symbol(),0,"ml-Zero lag Hull moving average - histo & alerts","H4", Length, Price,1,i+1);
     
    /* 
     SMA1a=iCustom(Symbol(),PERIOD_M15,"ml-Zero lag Hull moving average - histo & alerts","0", Length, Price,0,i+1);
     SMA1b=iCustom(Symbol(),PERIOD_M15,"ml-Zero lag Hull moving average - histo & alerts","0", Length, Price,1,i+1);
     SMA2a=iCustom(Symbol(),PERIOD_H1, "ml-Zero lag Hull moving average - histo & alerts","0", Length, Price,0,i+1);
     SMA2b=iCustom(Symbol(),PERIOD_H1, "ml-Zero lag Hull moving average - histo & alerts","0", Length, Price,1,i+1);
     SMA3a=iCustom(Symbol(),PERIOD_H4, "ml-Zero lag Hull moving average - histo & alerts","0", Length, Price,0,i+1);
     SMA3b=iCustom(Symbol(),PERIOD_H4 ,"ml-Zero lag Hull moving average - histo & alerts","0", Length, Price,1,i+1);
   */ Print(SMA1a,"  ", SMA2a,"   ",SMA3a);
     if((SMA1a ==1 && SMA2a ==1 && SMA3a ==1))  //Buy
      {
        if(Reverse) SV=1; else BV=1; break;
      }
      if((SMA1b ==1 && SMA2b ==1 && SMA3b ==1))    //Sell
      {
         if(Reverse) BV=1; else SV=1; break;
      }
   
   // expert conditions to close position  
      if((SMA1b ==1 && OrderType()==OP_BUY )) 
      {
         CBV=1;  break;                            //close buy    ///SMA2a > 0 && SMA3a > 0))  //Buy
      } 
     if((SMA1a ==1 && OrderType()==OP_SELL)) 
      { 
         CSV=1;  break;  
      }                                   //close sell
                    
        
       /*  
     if((SMA1a<SMA3a && SMA1b>SMA3b)||(SMA1a<SMA2a && SMA1b>SMA2b && SMA2b>SMA3b))
      {
        if(Reverse) SV=1; else BV=1; break;
      }
      if((SMA1a>SMA3a && SMA1b<SMA3b)||(SMA1a>SMA2a && SMA1b<SMA2b && SMA2b<SMA3b))
      {
         if(Reverse) BV=1; else SV=1; break;
      }*/
   }

   // expert money management
   if(MM)
   {
      if(Risk<0.1 || Risk>100) {Comment("Invalid Risk Value."); return(0);
      }
      else 
      {
      MML=MathFloor((AccountFreeMargin() *AccountLeverage()*Risk*pointvalue*100)/(Ask*MarketInfo(Symbol(),
      MODE_LOTSIZE)*MarketInfo(Symbol(),MODE_MINLOT )))*MarketInfo(Symbol(),MODE_MINLOT );
   }
 }
   if(MM==false)
   {
   MML=Lots;
   }

   // expert init positions
   int cnt=0,OP=0,OS=0,OB=0,CS=0,CB=0;OP=0;
 for(cnt=0; cnt<OrdersTotal();cnt++) 
 {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((OrderType()==OP_SELL || OrderType()==OP_BUY) && OrderSymbol()==Symbol() && ((OrderMagicNumber()==Magic) || Magic==0)) OP=OP+1;
      }
      if(OP>=1)
      {
      OS=0; OB=0;
      }
      OB=0;OS=0;CB=0;CS=0;

   // expert conditions to open position
      if(SV>0)
      {
         OS=1;OB=0;
      }
      if(BV>0)
      {
         OB=1;OS=0;
      }

   // expert conditions to close position
      if((CSV>0 ) || (RealSL_Enabled && (OrderOpenPrice()-Bid)/pointvalue>=RealSL)||(RealTP_Enabled && (Ask-OrderOpenPrice())/pointvalue>=RealTP))
      {
      CB=1;
      }
      if((CBV>0) || (RealSL_Enabled && (Ask-OrderOpenPrice())/pointvalue>=RealSL)||(RealTP_Enabled && (OrderOpenPrice()-Bid)/pointvalue>=RealTP))
      {
      CS=1;
      }
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
	     if(OrderType()==OP_BUY && OrderSymbol()==Symbol() && ((OrderMagicNumber()==Magic) || Magic==0))
	     {
	        if (CB==1)
	        {
	        OrderClose(OrderTicket(),OrderLots(),Bid,Slip,Red); return(0);
	        }
        }
	     if(OrderType()==OP_SELL && OrderSymbol()==Symbol() && ((OrderMagicNumber()==Magic) || Magic==0))
	     {
	        if(CS==1)
	        {
	        OrderClose(OrderTicket(),OrderLots(),Ask,Slip,Red);return(0);
	        }
	     }
	}
	double SLI=0,TPI=0;int TK=0;

   // expert open position value
 if((AddP() && Add_Positions && OP<=MaxOrders) || (OP==0 && !Add_Positions))
 {
    if(OS==1)
     {
	     if (TP==0) TPI=0; else TPI=Bid-TP*pointvalue;
	     if (SL==0) SLI=0; else SLI=Bid+SL*pointvalue;
	     TK=OrderSend(Symbol(),OP_SELL,MML,Bid,Slip,0,0,OrSt,Magic,0,Red);
        if(TK > 0)
         {
            if (OrderSelect(TK, SELECT_BY_TICKET, MODE_TRADES))
            {
             OrderModify(TK,OrderOpenPrice(),SLI, TPI,0,DarkRed);
             Print("Sell order Modified:-ticket #  " , TK," ", OrderOpenPrice());
            }                     
         }
      else Print("Error opening Sell order : ", GetLastError());
      OS=0;
      return(0);
     }
    if(OB==1)
	  {
	     if(TP==0) TPI=0; else TPI=Ask+TP*pointvalue;
	     if(SL==0) SLI=0; else SLI=Ask-SL*pointvalue;
	     TK=OrderSend(Symbol(),OP_BUY,MML,Ask,Slip,0,0,OrSt,Magic,0,Lime);
	     if(TK > 0)
         {
            if (OrderSelect(TK, SELECT_BY_TICKET, MODE_TRADES))
            {
             OrderModify(TK,OrderOpenPrice(),SLI, TPI,0,DarkRed);
             Print("BUY order Modified:-ticket #  " , TK," ", OrderOpenPrice());
            }                     
         }
     else Print("Error opening Buy order : ", GetLastError());
	  }
       OB=0; 
       return(0);
 }
   for(j=0;j<OrdersTotal();j++){if(OrderSelect(j,SELECT_BY_POS, MODE_TRADES))
   {
      if (OrderSymbol()==Symbol() && ((OrderMagicNumber()==Magic) || Magic==0)) {TrP();}}}return(0);
   }

   // expert number of orders
   int CntO(int Type,int Magic)
   {
      int _CntO;_CntO=0;
      for(int j=0;j<OrdersTotal();j++)
      {
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol()==Symbol())
            {
            if((OrderType()==Type && (OrderMagicNumber()==Magic) || Magic==0)) _CntO++;
            }
      }
   return(_CntO);
   }
   // expert trailing stop
 void TrP()
 {
   double pb,pa,pp;
   pp=MarketInfo(OrderSymbol(),MODE_POINT);
   if (OrderType()==OP_BUY)
      {
      pb=MarketInfo(OrderSymbol(),MODE_BID);

      //expert breakeven
       if(BE>0)
       {
         if((pb-OrderOpenPrice())>BE*pp)
         {
            if((OrderStopLoss()-OrderOpenPrice())<0)
            {
               ModSL(OrderOpenPrice()+0*pp);
            }
         }
       }
    if(TS>0)
    {
      if((pb-OrderOpenPrice())>TS*pp)
      {
         if(OrderStopLoss()<pb-(TS+TS_Step-1)*pp)
         {
         ModSL(pb-TS*pp);return;
         }
      }
    }
   }
  if(OrderType()==OP_SELL)
  {
   pa=MarketInfo(OrderSymbol(),MODE_ASK);
   if(BE>0){if((OrderOpenPrice()-pa)>BE*pp)
   {
   if((OrderOpenPrice()-OrderStopLoss())<0)
   {
   ModSL(OrderOpenPrice()-0*pp);
   }
   }
   }
  if (TS>0)
  {
  if (OrderOpenPrice()-pa>TS*pp)
  {
  if (OrderStopLoss()>pa+(TS+TS_Step-1)*pp || OrderStopLoss()==0){ModSL(pa+TS*pp);return;
  }
  }
  }
  }
  }

   //expert stoploss
  void ModSL(double ldSL)
  {
  bool fm;fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldSL,OrderTakeProfit(),0,CLR_NONE);
  }

   //expert add positions function
   bool AddP()
   {
   int _num=0; int _ot=0;
   for (int j=0;
   j<OrdersTotal();
   j++)
   {
   if(OrderSelect(j,SELECT_BY_POS)==true && OrderSymbol()==Symbol() && OrderType()<3 && ((OrderMagicNumber()==Magic) || Magic==0)) 
   {	
	 _num++;if(OrderOpenTime()>_ot) _ot=OrderOpenTime();
	 }
	 }
   if(_num==0) return(true);
   if(_num>0 && ((Time[0]-_ot))>0) return(true);else return(false);
   }